/*
 *  Abstraction layer for MIDI v1.0 stream
 *  Copyright (c) by Jaroslav Kysela <perex@jcu.cz>
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
 
#define SND_MIDI_HW_POLL	0x00000001	/* polled mode */

typedef struct snd_stru_rawmidi_direction snd_rawmidi_direction_t;
typedef struct snd_stru_rawmidi snd_rawmidi_t;

struct snd_stru_rawmidi_direction_hw {
  unsigned int flags;				/* SND_MIDI_HW_XXXX */
  void *private_data;
  void (*private_free)( void *private_data );
  int (*open)( snd_rawmidi_t *rmidi );
  int (*close)( snd_rawmidi_t *rmidi );
  int (*read)( snd_rawmidi_t *rmidi, unsigned char *buffer, int count );
  int (*write)( snd_rawmidi_t *rmidi, unsigned char *buffer, int count );
  int (*abort)( snd_rawmidi_t *rmidi );
};

struct snd_stru_rawmidi_direction {
  unsigned char *buffer;			/* buffer for MIDI data */
  unsigned int size;				/* size of buffer */
  unsigned int head;				/* buffer head index */
  unsigned int tail;				/* buffer tail index */
  unsigned int used;				/* buffer used index */
  struct snd_stru_midi_direction_hw hw;
};
 
struct snd_stru_rawmidi {
  snd_card_t *card;

  unsigned int info_flags;			/* SND_MIDI_INFO_XXXX */

  snd_midi_direction_t input;
  snd_midi_direction_t output;

  void *private_data;
  void (*private_free)( void *private_data );
};
